import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import Button from '@s-ui/react-atom-button';
import TcfSecondLayerUserDecision from '../tcf-secondLayer-user-decision';
import TcfSecondLayerVendorsUserDecision from '../tcf-secondLayer-vendors-user-decision';
export function TcfSecondLayerDecisionGroup(_ref) {
  var name = _ref.name,
      i18n = _ref.i18n,
      baseClass = _ref.baseClass,
      descriptions = _ref.descriptions,
      state = _ref.state,
      filteredIds = _ref.filteredIds,
      hasConsent = _ref.hasConsent,
      _onConsentChange = _ref.onConsentChange,
      onAcceptAll = _ref.onAcceptAll,
      onRejectAll = _ref.onRejectAll,
      vendorList = _ref.vendorList,
      expandedContent = _ref.expandedContent,
      isVendorLayer = _ref.isVendorLayer;

  var _useState = useState(null),
      descriptionKeys = _useState[0],
      setDescriptionKeys = _useState[1];

  useEffect(function () {
    var asyncUseEffect = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var keys, toFilter;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                keys = descriptions && Object.keys(descriptions).map(function (key) {
                  return parseInt(key);
                });

                if (!filteredIds) {
                  _context.next = 6;
                  break;
                }

                _context.next = 4;
                return filteredIds();

              case 4:
                toFilter = _context.sent;
                keys = keys.filter(function (key) {
                  return toFilter.includes(key);
                });

              case 6:
                setDescriptionKeys(keys);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function asyncUseEffect() {
        return _ref2.apply(this, arguments);
      };
    }();

    asyncUseEffect();
  }, [descriptions, filteredIds]);

  if (!(descriptionKeys == null ? void 0 : descriptionKeys.length)) {
    return null;
  }

  var ButtonAll = /*#__PURE__*/React.memo(function () {
    return /*#__PURE__*/React.createElement("div", {
      className: baseClass + "Header-buttons"
    }, /*#__PURE__*/React.createElement(Button, {
      size: "small",
      design: "outline",
      onClick: onRejectAll
    }, i18n.DISABLE_BUTTON), /*#__PURE__*/React.createElement(Button, {
      size: "small",
      onClick: onAcceptAll
    }, i18n.ENABLE_BUTTON));
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "Header"
  }, /*#__PURE__*/React.createElement("h5", {
    className: baseClass + "Header-title"
  }, name), hasConsent ? /*#__PURE__*/React.createElement(ButtonAll, null) : null), descriptionKeys.map(function (key, index) {
    var consentValue = (state == null ? void 0 : state.consents) ? state.consents[key] : state == null ? void 0 : state[key];
    return isVendorLayer ? /*#__PURE__*/React.createElement(TcfSecondLayerUserDecision, {
      key: key + "-" + index,
      baseClass: "" + baseClass,
      info: descriptions[key],
      consentValue: consentValue,
      hasConsent: hasConsent,
      i18n: i18n,
      vendorList: vendorList,
      onConsentChange: function onConsentChange(value) {
        return _onConsentChange({
          index: key,
          value: value
        });
      },
      expandedContent: expandedContent
    }) : /*#__PURE__*/React.createElement(TcfSecondLayerVendorsUserDecision, {
      key: key + "-" + index,
      baseClass: "" + baseClass,
      info: descriptions[key],
      consentValue: consentValue,
      hasConsent: hasConsent,
      i18n: i18n,
      vendorList: vendorList,
      onConsentChange: function onConsentChange(value) {
        return _onConsentChange({
          index: key,
          value: value
        });
      },
      expandedContent: expandedContent
    });
  }));
}
export default /*#__PURE__*/React.memo(TcfSecondLayerDecisionGroup);