import _extends from "@babel/runtime/helpers/esm/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import { useConsent } from '@s-ui/react-tcf-services';
import SuiModal from '@s-ui/react-molecule-modal';
import Button from '@s-ui/react-atom-button';
import IconClose from './components/iconClose';
import TcfSecondLayerDecisionGroup from './components/tcf-secondLayer-decision-group';
import TcfSecondLayerVendorExpandedContent from './components/tcf-secondLayer-vendor-expandedContent';
import { I18N } from './settings';
import TcfSecondLayerLegalExpandedContent from './components/tcf-secondLayer-legal-expandedContent';
var CLASS = 'sui-TcfSecondLayer';
var groupBaseClass = CLASS + "-group";
export default function TcfSecondLayer(_ref) {
  var logo = _ref.logo,
      saveUserConsent = _ref.saveUserConsent,
      onGoBack = _ref.onGoBack,
      onVendorsClick = _ref.onVendorsClick,
      isVendorLayer = _ref.isVendorLayer;

  var _useState = useState(null),
      state = _useState[0],
      setState = _useState[1];

  var _useState2 = useState(true),
      modalOpen = _useState2[0],
      setModalOpen = _useState2[1];

  var _useState3 = useState(null),
      vendorListState = _useState3[0],
      setVendorListState = _useState3[1];

  var _useConsent = useConsent(),
      language = _useConsent.language,
      isMobile = _useConsent.isMobile,
      getVendorList = _useConsent.getVendorList,
      getScope = _useConsent.getScope,
      loadUserConsent = _useConsent.loadUserConsent,
      updateUserConsent = _useConsent.updateUserConsent;

  var i18n = I18N[language];
  useEffect(function () {
    var getVendorListAndConsent = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _yield$getVendorList, purposes, specialPurposes, features, specialFeatures, vendors, userConsent;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return getVendorList();

              case 2:
                _yield$getVendorList = _context.sent;
                purposes = _yield$getVendorList.purposes;
                specialPurposes = _yield$getVendorList.specialPurposes;
                features = _yield$getVendorList.features;
                specialFeatures = _yield$getVendorList.specialFeatures;
                vendors = _yield$getVendorList.vendors;
                setVendorListState({
                  purposes: purposes,
                  specialPurposes: specialPurposes,
                  features: features,
                  specialFeatures: specialFeatures,
                  vendors: vendors
                });
                _context.next = 11;
                return loadUserConsent();

              case 11:
                userConsent = _context.sent;
                setState({
                  vendors: userConsent.vendor,
                  purposes: userConsent.purpose,
                  specialFeatures: userConsent.specialFeatures
                });

              case 13:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function getVendorListAndConsent() {
        return _ref2.apply(this, arguments);
      };
    }();

    getVendorListAndConsent();
  }, [getVendorList, loadUserConsent]);

  var handleCloseModal = function handleCloseModal() {
    setModalOpen(false);
  };

  var handleSaveExitClick = function handleSaveExitClick() {
    saveUserConsent();
    handleCloseModal();
  };

  var saveConsentState = function saveConsentState(_ref3) {
    var purposes = _ref3.purposes,
        vendors = _ref3.vendors,
        specialFeatures = _ref3.specialFeatures;
    return updateUserConsent({
      purpose: purposes,
      vendor: vendors,
      specialFeatures: specialFeatures
    });
  };

  var changeAllGroup = function changeAllGroup(_ref4) {
    var group = _ref4.group,
        value = _ref4.value;
    setState(function (prevState) {
      var _extends2;

      for (var key in vendorListState[group]) {
        prevState[group].consents[key] = value;
        prevState[group].legitimateInterests[key] = value;
      }

      var nextState = _extends({}, prevState, (_extends2 = {}, _extends2[group] = prevState[group], _extends2));

      saveConsentState(nextState);
      return nextState;
    });
  };

  var handleRejectAll = function handleRejectAll(_ref5) {
    var group = _ref5.group;
    changeAllGroup({
      group: group,
      value: false
    });
  };

  var handleAcceptAll = function handleAcceptAll(_ref6) {
    var group = _ref6.group;
    changeAllGroup({
      group: group,
      value: true
    });
  };

  var handleAcceptAllSpecialFeatures = /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var specialFeatures, scope, nextState;
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              specialFeatures = {};
              _context2.next = 3;
              return getScope();

            case 3:
              scope = _context2.sent;
              scope.specialFeatures.forEach(function (value) {
                return specialFeatures[value] = true;
              });
              nextState = _extends({}, state, {
                specialFeatures: specialFeatures
              });
              saveConsentState(nextState);
              setState(nextState);

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function handleAcceptAllSpecialFeatures() {
      return _ref7.apply(this, arguments);
    };
  }();

  var handleRejectAllSpecialFeatures = function handleRejectAllSpecialFeatures() {
    var nextState = _extends({}, state, {
      specialFeatures: {}
    });

    saveConsentState(nextState);
    setState(nextState);
  };

  var handleConsentsChange = function handleConsentsChange(_ref8) {
    var group = _ref8.group,
        index = _ref8.index,
        value = _ref8.value;
    setState(function (prevState) {
      var _prevState$group = prevState[group],
          consents = _prevState$group.consents,
          legitimateInterests = _prevState$group.legitimateInterests;

      if (consents && legitimateInterests) {
        var _extends3;

        consents[index] = !value;
        legitimateInterests[index] = !value;

        var nextState = _extends({}, prevState, (_extends3 = {}, _extends3[group] = _extends({}, prevState[group], {
          consents: consents,
          legitimateInterests: legitimateInterests
        }), _extends3));

        saveConsentState(nextState);
        return nextState;
      } else {
        var _extends4, _extends5;

        var _nextState = _extends({}, prevState, (_extends5 = {}, _extends5[group] = _extends({}, prevState[group], (_extends4 = {}, _extends4[index] = !value, _extends4)), _extends5));

        saveConsentState(_nextState);
        return _nextState;
      }
    });
  };

  var Logo = /*#__PURE__*/React.memo(function () {
    return /*#__PURE__*/React.createElement("img", {
      className: CLASS + "-logo",
      src: logo,
      alt: "logo"
    });
  });

  var vendorExpandedContent = function vendorExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerVendorExpandedContent, Object.assign({}, props, {
      i18n: i18n,
      baseClass: groupBaseClass,
      vendorList: vendorListState
    }));
  };

  var legalExpandedContent = function legalExpandedContent(props) {
    return /*#__PURE__*/React.createElement(TcfSecondLayerLegalExpandedContent, Object.assign({}, props, {
      baseClass: groupBaseClass + "-expanded"
    }));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: CLASS
  }, /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: modalOpen,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: isMobile ? /*#__PURE__*/React.createElement(Logo, null) : false,
    iconClose: isMobile ? /*#__PURE__*/React.createElement(IconClose, null) : false,
    onClose: handleSaveExitClick,
    fitContent: true,
    portalContainerId: "sui-TcfSecondLayerModal"
  }, !isMobile && /*#__PURE__*/React.createElement(Logo, null), /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-main"
  }, /*#__PURE__*/React.createElement("h4", {
    className: CLASS + "-title"
  }, isVendorLayer ? i18n.VENDOR_PAGE.TITLE : i18n.SECOND_LAYER.TITLE), /*#__PURE__*/React.createElement("p", null, isVendorLayer ? i18n.VENDOR_PAGE.TEXT : i18n.SECOND_LAYER.TEXT), !!(vendorListState == null ? void 0 : vendorListState.purposes) && !!(state == null ? void 0 : state.purposes) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.purposes,
    state: state.purposes,
    filteredIds: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3() {
      var scope;
      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return getScope();

            case 2:
              scope = _context3.sent;
              return _context3.abrupt("return", scope.purposes);

            case 4:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    })),
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'purposes'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'purposes'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'purposes'
      });
    },
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.specialFeatures) && !!(state == null ? void 0 : state.specialFeatures) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialFeatures,
    state: state.specialFeatures,
    filteredIds: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
      var scope;
      return _regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return getScope();

            case 2:
              scope = _context4.sent;
              return _context4.abrupt("return", scope.specialFeatures);

            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    })),
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'specialFeatures'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: handleAcceptAllSpecialFeatures,
    onRejectAll: handleRejectAllSpecialFeatures,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.specialPurposes) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.SPECIAL_PURPOSES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.specialPurposes,
    hasConsent: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(vendorListState == null ? void 0 : vendorListState.features) && !isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.SECOND_LAYER.FEATURES_TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.features,
    hasConsent: false,
    i18n: i18n,
    vendorList: vendorListState,
    expandedContent: legalExpandedContent,
    isVendorLayer: isVendorLayer
  }), !!(state == null ? void 0 : state.vendors) && !!(vendorListState == null ? void 0 : vendorListState.vendors) && isVendorLayer && /*#__PURE__*/React.createElement(TcfSecondLayerDecisionGroup, {
    name: i18n.VENDOR_PAGE.GROUPS.TITLE,
    baseClass: groupBaseClass,
    descriptions: vendorListState.vendors,
    state: state.vendors,
    onConsentChange: function onConsentChange(props) {
      return handleConsentsChange(_extends({
        group: 'vendors'
      }, props));
    },
    hasConsent: true,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'vendors'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'vendors'
      });
    },
    vendorList: vendorListState,
    expandedContent: vendorExpandedContent,
    isVendorLayer: isVendorLayer
  })), /*#__PURE__*/React.createElement("footer", {
    className: CLASS + "-footer"
  }, !isMobile && !isVendorLayer && /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-footer--link"
  }, /*#__PURE__*/React.createElement(Button, {
    size: "small",
    design: "link",
    onClick: function onClick() {
      onVendorsClick && onVendorsClick();
    }
  }, i18n.SECOND_LAYER.PARTNERS_LINK)), /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-footer--buttons"
  }, /*#__PURE__*/React.createElement(Button, {
    design: "outline",
    size: "small",
    onClick: onGoBack
  }, i18n.GO_BACK_BUTTON), /*#__PURE__*/React.createElement(Button, {
    size: "small",
    onClick: handleSaveExitClick
  }, i18n.ACCEPT_BUTTON)))));
}
TcfSecondLayer.displayName = 'TcfSecondLayer';